from ctypes import *

from common_application_interface_def import *

from common_sensor_interface_def import *

from m2m2_core_def import *

class M2M2_AD7689_APP_CMD_ENUM_t(c_ubyte):
    _M2M2_AD7689_APP_CMD_LOWEST = 0x40
    M2M2_AD7689_APP_CMD_WRITE_LCFG_REQ = 0x42
    M2M2_AD7689_APP_CMD_WRITE_LCFG_RESP = 0x43
    M2M2_AD7689_APP_CMD_READ_LCFG_REQ = 0x44
    M2M2_AD7689_APP_CMD_READ_LCFG_RESP = 0x45
    M2M2_AD7689_APP_CMD_SET_LCFG_REQ = 0x46
    M2M2_AD7689_APP_CMD_SET_LCFG_RESP = 0x47

class M2M2_SENSOR_AD7689_NSAMPLES_ENUM_t(c_ubyte):
    M2M2_SENSOR_AD7689_NSAMPLES = 0x6

class M2M2_SENSOR_AD7689_RAW_DATA_TYPES_ENUM_t(c_ubyte):
    M2M2_SENSOR_AD7689_DATA = 0x0

class AD7689_app_lib_state_t(Structure):
    _pack_ = 1
    _fields_ = [
              ("command", c_ubyte),
              ("status", c_ubyte),
              ("states", c_ubyte * 10),
              ]

class AD7689_app_lcfg_op_t(Structure):
    _pack_ = 1
    _fields_ = [
              ("field", c_ubyte),
              ("value", c_ulong),
              ]

def AD7689_app_lcfg_op_hdr_t(array_size):
  class AD7689_app_lcfg_op_hdr_t_internal(Structure):
    _pack_ = 1
    _fields_ = [
              ("command", c_ubyte),
              ("status", c_ubyte),
              ("num_ops", c_ubyte),
              ("ops", AD7689_app_lcfg_op_t * array_size),
              ]
  return AD7689_app_lcfg_op_hdr_t_internal()

class AD7689_app_set_lcfg_t(Structure):
    _pack_ = 1
    _fields_ = [
              ("command", c_ubyte),
              ("status", c_ubyte),
              ("lcfgid", c_ushort),
              ]

