from ctypes import *

from common_application_interface_def import *

from m2m2_core_def import *

class M2M2_PS_SYS_PWR_STATE_ENUM_t(c_ubyte):
    M2M2_PS_SYS_PWR_STATE_ACTIVE = 0x0
    M2M2_PS_SYS_PWR_STATE_FLEXI = 0x1
    M2M2_PS_SYS_PWR_STATE_HIBERNATE = 0x2
    M2M2_PS_SYS_PWR_STATE_SHUTDOWN = 0x3

class M2M2_PS_SYS_COMMAND_ENUM_t(c_ubyte):
    __M2M2_PS_SYS_COMMAND_LOWEST = 0x40
    M2M2_PS_SYS_COMMAND_SET_DATE_TIME_REQ = 0x42
    M2M2_PS_SYS_COMMAND_SET_DATE_TIME_RESP = 0x43
    M2M2_PS_SYS_COMMAND_SET_PWR_STATE_REQ = 0x44
    M2M2_PS_SYS_COMMAND_SET_PWR_STATE_RESP = 0x45
    M2M2_PS_SYS_COMMAND_GET_PS_APPS_INFO_REQ = 0x48
    M2M2_PS_SYS_COMMAND_GET_PS_APPS_INFO_RESP = 0x49
    M2M2_PS_SYS_COMMAND_ACTIVATE_TOUCH_SENSOR_REQ = 0x4A
    M2M2_PS_SYS_COMMAND_ACTIVATE_TOUCH_SENSOR_RESP = 0x4B
    M2M2_PS_SYS_COMMAND_DEACTIVATE_TOUCH_SENSOR_REQ = 0x4C
    M2M2_PS_SYS_COMMAND_DEACTIVATE_TOUCH_SENSOR_RESP = 0x4D
    M2M2_PS_SYS_COMMAND_GET_BOARD_INFO_REQ = 0x4E
    M2M2_PS_SYS_COMMAND_GET_BOARD_INFO_RESP = 0x4F
    M2M2_PS_SYS_COMMAND_SYSTEM_RESET_REQ = 0x50
    M2M2_PS_SYS_COMMAND_SYSTEM_RESET_RESP = 0x51

class ADI_PS_BOARD_TYPE_t(c_ubyte):
    ADI_PS_BOARD_TYPE_UNKNOWN = 0x0
    ADI_PS_BOARD_TYPE_ADPD107_WATCH = 0x1
    ADI_PS_BOARD_TYPE_ADPD107_CHEST_STRAP = 0x2
    ADI_PS_BOARD_TYPE_ADPD185_WATCH = 0x3
    ADI_PS_BOARD_TYPE_ADPD188_WATCH = 0x4

class M2M2_PS_SYS_STATUS_ENUM_t(c_ubyte):
    __M2M2_PS_SYS_STATUS_LOWEST = 0x40
    M2M2_PS_SYS_STATUS_OK = 0x41
    M2M2_PS_SYS_STATUS_ERR_ARGS = 0x42
    M2M2_PS_SYS_STATUS_ERR_NOT_CHKD = 0xFF

class m2m2_ps_sys_cmd_t(Structure):
    _pack_ = 1
    _fields_ = [
              ("command", c_ubyte),
              ("status", c_ubyte),
              ]

class m2m2_ps_sys_pwr_state_t(Structure):
    _pack_ = 1
    _fields_ = [
              ("command", c_ubyte),
              ("status", c_ubyte),
              ("state", c_ubyte),
              ]

class m2m2_ps_sys_date_time_req_t(Structure):
    _pack_ = 1
    _fields_ = [
              ("command", c_ubyte),
              ("status", c_ubyte),
              ("year", c_ushort),
              ("month", c_ubyte),
              ("day", c_ubyte),
              ("hour", c_ubyte),
              ("minute", c_ubyte),
              ("second", c_ubyte),
              ("TZ_sec", c_ulong),
              ]

class m2m2_ps_sys_board_info_req_t(Structure):
    _pack_ = 1
    _fields_ = [
              ("command", c_ubyte),
              ("status", c_ubyte),
              ("version", c_ushort),
              ("mac_addr", c_ubyte * 6),
              ("device_id", c_ulong),
              ("model_number", c_ulong),
              ("hw_id", c_ushort),
              ("bom_id", c_ushort),
              ("batch_id", c_ubyte),
              ("date", c_ulong),
              ("board_type", c_ubyte),
              ]

class m2m2_ps_sys_sensor_app_status(Structure):
    _pack_ = 1
    _fields_ = [
              ("sensor_app_id", c_ushort),
              ("num_subscribers", c_ubyte),
              ("num_start_reqs", c_ubyte),
              ]

class m2m2_ps_sys_sensor_apps_info_req_t(Structure):
    _pack_ = 1
    _fields_ = [
              ("command", c_ubyte),
              ("status", c_ubyte),
              ("num_sensor_apps", c_ushort),
              ("app_info", m2m2_ps_sys_sensor_app_status * 15),
              ]

